/* pcre_match(), pcre_replace(), split(), YM_split()  */
#include "url_pattern.h"


#if __RUN_MAIN
void start_timer(struct timeval *start_time)
{
    gettimeofday(start_time, NULL);
}


void end_timer(struct timeval *end_time)
{
    gettimeofday(end_time, NULL);
}

// ߰߰ ó ð ֱ  ߰ by Noh
void processed_time(struct timeval* start, struct timeval *end)
{
    int sec_buf,microsec_buf;
    float time_buf;

    sec_buf = end->tv_sec - start->tv_sec;
    microsec_buf = end->tv_usec - start->tv_usec;

    time_buf = microsec_buf;
    time_buf = time_buf / 1000000;
    time_buf = time_buf + sec_buf;

    printf("[ó ð]: %f\n", time_buf);
}


int main(int argc, char **argv)
{
	FILE			*fp;
	char			buff[MAX_BUFF], mat_url[MAX_BUFF];
	struct timeval	start_time, end_time;
	URL_LINK		url_list, node;


#if 0
	if (argc != 2) {
		fLOG_PRINT(stderr, "<usage>: %s <url_string>\n", argv[0]);

		return 0;
	}

	if (chk_url_pattern(argv[1], mat_url))
		LOG_PRINT("Matched: [s] %s\n", mat_url argv[1]);
	else
		LOG_PRINT("Not Matched: [%s] %s\n", mat_url, argv[1]);
#else
	if (argc != 2) {
		fprintf(stderr, "<usage>: %s <filename>\n", argv[0]);

		return 0;
	}

	if ((fp = fopen(argv[1], "r")) == NULL) {
		perror("fopen()");

		return -1;
	}

	start_timer(&start_time);

	/* read text from file */
	while (fgets(buff, MAX_BUFF, fp) != NULL) {
		memset(mat_url, 0, MAX_BUFF);

		/* Minimum length of URL: http://1.1.1.1 */
		if (strlen(buff) > 14)
			chk_url_pattern(buff, mat_url);

		if (mat_url[0]) {
			/* check duplicated url.
			   if exist URL then ignore and read a next line. */	
			if (url_list && url_list_search_url(url_list, mat_url))	
				continue;

			if ((node = url_list_create_node(mat_url))) {
				if (url_list) /* ADD: concatenate node to list of url */
					url_list_concatenate_list(&url_list, node);
				else /* NEW: create list of url */
					url_list = node;
			}
			else break;	/* break while loop */
		}
	}

	/* print list of url */
	LOG_PRINT_F("\nMatched list...\n");
	url_list_print_list(url_list);
	LOG_PRINT_F("\n");

	/* free list of url */
	url_list_free_list(url_list);

	end_timer(&end_time);
	
	processed_time(&start_time, &end_time);
#endif


	return 0;
}
#endif


/* check pattern of url in text */
#if __URL_PCRE
/* url_str - input text
   mat_url - matched url
   */
char *chk_url_pattern(char *url_str, char *mat_url)
{
	char		pc_pattern[MAX_PAT_ADDR];
	/* START: Declaration of PCRE */
	pcre		*re;
	const char	*error;
	int			erroffset;
	int 		ovector[OVECCOUNT];
	int 		rc, i;
	char 		*substring_start;
	int 		substring_length;
	/* END: Declaration of PCRE */


	if (url_str == NULL)
		return NULL;

	/* exceed to length of maximum */
	if (strlen(PAT_URL) >= MAX_PAT_ADDR)
		return NULL;

#if 0
	LOG_PRINT("url_str = %s\n", url_str);
#endif

	strncpy(pc_pattern, PAT_URL, MAX_PAT_ADDR);

	/* compile */
	/*  Compile the regular expression in the first argument
	 */
	re = pcre_compile(
			PAT_URL,     /* the pattern */
			0,           /* default options */
			&error,      /* for error message */
			&erroffset,  /* for error offset */
			NULL);       /* use default character tables */

	
	if (re == NULL) {
		LOG_PRINT("PCRE compilation failed at offset %d: %s\n", 
				erroffset, error);

		return NULL;
	}

	/* execute */
	rc = pcre_exec(
			re,          /* the compiled pattern */
			NULL,        /* we didn't study the pattern */
			url_str,     /* the subject string */
			(int)strlen(url_str), /* the length of the subject */
			0,           /* start at offset 0 in the subject */
			0,           /* default options */
			ovector,     /* vector for substring information */
			OVECCOUNT);  /* number of elements in the vector */

	/* Matching failed: handle error cases */
	if (rc < 0) {
		switch(rc) {
			case PCRE_ERROR_NOMATCH:   
				//LOG_PRINT("No   match\n");
				break;
			default: 
				LOG_PRINT("Matching error %d\n", rc); 
				break;
		}

		return NULL;
	}

	/* Match succeded */
	//LOG_PRINT("Match succeeded\n");

	/* The output vector wasn't big enough */
	if (rc == 0) {
		rc = OVECCOUNT/3;
		printf("ovector only has room for %d captured substrings\n", rc - 1);
	}

	/* Show substrings stored in the output vector */
#if __URL_ONE
	/*  ο ϳ URL ´. */
	i = 0;
	substring_start = url_str + *(ovector + 2*i);
	substring_length = *(ovector + 2*i+1) - *(ovector + 2*i);
	strncpy(mat_url, substring_start, substring_length);
#else
	/* ο ִ  URL ´. */
	/* delimeter ̿Ͽ mat_url Ѵ. */
	for (i = 0; i < rc; i++) {
		substring_start = url_str + *(ovector + 2*i);
		substring_length = *(ovector + 2*i+1) - *(ovector + 2*i);

		//LOG_PRINT("%2d: %.*s\n", i, substring_length, substring_start);
		strncpy(mat_url, substring_start, substring_length);
	}
#endif

#if 0
	LOG_PRINT("matched string = [%s][%d][%d]\n", 
			url_str, pmatch.rm_so, pmatch.rm_eo);
	LOG_PRINT("url = [%s]\n", mat_url);
#endif


	return mat_url;
}
#else
char *chk_url_pattern(char *url_str, char *mat_url)
{
	int			status;
	char		pc_pattern[MAX_PAT_ADDR];
	int			pos = 0, size = 0;
	regex_t		comp;
	regmatch_t	pmatch;


	if (url_str == NULL)
		return NULL;

	/* exceed to length of maximum */
	if (strlen(PAT_URL) >= MAX_PAT_ADDR)
		return NULL;

#if 0
	LOG_PRINT("url_str = %s\n", url_str);
#endif

	strncpy(pc_pattern, PAT_URL, MAX_PAT_ADDR);

	/* compile */
	if (regcomp(&comp, pc_pattern, CFLAGS))
		return NULL;

	/* execute */
	status = regexec(&comp, url_str, (size_t)1, &pmatch, 0);

	if (status) {
		/* free */
		regfree(&comp);

		return NULL;
	}

	pos = pmatch.rm_so + 7;
	size = pmatch.rm_eo - pmatch.rm_so - 7;
	strncpy(mat_url, url_str + pos, size);

#if 0
	LOG_PRINT("matched string = [%s][%d][%d]\n", url_str, pmatch.rm_so, pmatch.rm_eo);
	LOG_PRINT("url = [%s]\n", mat_url);
#endif

	/* free */
	regfree(&comp);


	return mat_url;
}
#endif

/* create node of url */
URL_LINK url_list_create_node(char *url)
{
	URL_LINK	node;


	if (!(node = (URL_LINK) malloc(sizeof(URL_LIST_ELM)))) {
		LOG_PRINT("malloc(): %s", strerror(errno));

		return NULL;
	}

	node->next = NULL;
	node->url = (char *) malloc(strlen(url)+1);

	strcpy(node->url, url);


	return node;
}

/* concatenate node to list. url_list is NEVER null. */
int url_list_concatenate_list(URL_LINK *url_list, URL_LINK node)
{
	if (*url_list)
		if ((*url_list)->next)
			url_list_concatenate_list(&(*url_list)->next, node);
		else
			(*url_list)->next = node;
	else
		return 1;	/* fail */


	return 0;	/* success */
}

/* search url in list */
int url_list_search_url(URL_LINK url_list, char *url)
{
	if (url_list) {
		if (strcmp(url_list->url, url))
			url_list_search_url(url_list->next, url);
		else
			return 1;	/* find */
	}
	else
		return 0;	/* not find */

	return 0;
}

/* free allocated memory (url_list) */
void url_list_free_list(URL_LINK url_list)
{
	if (url_list) {
		if (url_list->next)
			url_list_free_list(url_list->next);

		free((URL_LINK)url_list);
	}
}

#if __RUN_MAIN
/* print list of url */
void url_list_print_list(URL_LINK url_list)
{
	if (url_list) {
		LOG_PRINT("  URL = [%s]\n", url_list->url);

		if (url_list->next)
			url_list_print_list(url_list->next);
	}
}

#endif
