#ifndef	__URL_PATTERN_H_
#define	__URL_PATTERN_H_

#if __RUN_MAIN
#include <sys/time.h>
#include <unistd.h>
#endif

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <errno.h>

#if __URL_PCRE
//#include <pcre/pcre.h>
#include <pcre.h>
#else
#include <regex.h>
#endif


#define PAT_URL             "http://(([a-zA-Z0-9][-a-zA-Z0-9]*([.][a-zA-Z0-9][-a-zA-Z0-9]*){1,3})+.(com|org|net|kr|us|jp|ca|de|to)|([0-9]{1,3}\\.([0-9]{1,3}\\.){2}[0-9]{1,3}))"
#define CFLAGS              REG_EXTENDED
#define MAX_PAT_ADDR        256
#define MAX_BUFF            4096
#define	OVECCOUNT			30

#if (__URL_DEBUG)
#define LOG_FORMAT1      " ## [%s:%s():%d]: "
#define LOG_FORMAT2      __FILE__, __FUNCTION__, __LINE__
#define LOG_PRINT(FMT, ...)  printf(LOG_FORMAT1 FMT, LOG_FORMAT2, __VA_ARGS__)
#define LOG_PRINT_F(FMT, ...)  printf(LOG_FORMAT1 FMT, LOG_FORMAT2 __VA_ARGS__)
#else
#define LOG_PRINT(...)          while (0);
#define LOG_PRINT_F(...)          while (0);
#endif


typedef struct __URL_LINKED_LIST {
	char                        *url;
	struct __URL_LINKED_LIST    *next;
} URL_LIST_ELM;

typedef URL_LIST_ELM    *URL_LINK;


/* Matched URL  ִ Ÿ pass */
/* Listing   - ü 10 */
char *chk_url_pattern(char *url_str, char *mat_url);

/* create node of url */
URL_LINK url_list_create_node(char *url);

/* concatenate node to list */
int url_list_concatenate_list(URL_LINK *url_list, URL_LINK node);

/* search url in list */
int url_list_search_url(URL_LINK url_list, char *url);

/* free allocated memory (url_list) */
void url_list_free_list(URL_LINK url_list);

#if __RUN_MAIN
/* print list of url */
void url_list_print_list(URL_LINK url_list);
#endif

#endif
